//#include<iostream>
#include<cstdio>
#include<cctype>
#include<cmath>
#include<cstdlib>
#include<algorithm>
#include<vector>
#include<string>
#include<list>
#include<deque>
#include<map>
#include<set>
#include<queue>
#include<stack>
#include<utility>
#include<sstream>
#include<cstring>
using namespace std;

#define FOR(I,A,B) for(int I=(A);I<=(B);I++)
#define FORD(I,A,B) for(int I=(A);I>=(B);I--)
#define REP(I,N) for(int I=0;I<(N);I++)
#define ALL(X) (X).begin(),(X).end()
#define PB push_back
#define MP make_pair
#define X first
#define Y second
#define INFTY 100000000
#define VAR(V,init) __typeof(init) V=(init)
#define FORE(I,C) for(VAR(I,(C).begin());I!=(C).end();I++)
#define SIZE(x) ((int)(x).size())

typedef vector<int> VI;
typedef pair<int,int> PII;
typedef long long ll;
typedef vector<string> VS;

ll nwd(ll a,ll b) { return !b?a:nwd(b,a%b); }
template <class T> inline T sqr(const T&a) { return a*a; }

#define MAXN 100000
#define MAXM 100000
#define MAXK 100000

vector<int> graf[MAXN], gs[MAXN];

set<PII> wynik;

set<PII> dwyn;

int rozwiaz_drzewo(int n, vector<int>* drzewo, vector<PII>& wymagania)
{
    FORE(it, wymagania)
    {
        int popr[MAXN];
        queue<int> q;
        REP(i, n)
            popr[i] = -1;
        popr[it->X] = -2;
        q.push(it->X);
        while(!q.empty())
        {
            int akt = q.front();
            q.pop();
            FORE(jt, drzewo[akt])
            {
                if(popr[*jt] == -1)
                {
                    popr[*jt] = akt;
                    q.push(*jt);
                    if(*jt == it->Y)
                        goto out;
                }
            }
        }
out:
        if(popr[it->Y] < 0)
            return 0;
        int akt = it->Y;
        while(popr[akt] != -2)
        {
            REP(i, SIZE(drzewo[akt]))
                if(drzewo[akt][i] == popr[akt])
                {
                    drzewo[akt][i] = drzewo[akt].back();
                    drzewo[akt].pop_back();
                }
            akt = popr[akt];
        }
    } 
    REP(i, n) FORE(it, drzewo[i])
        if(dwyn.count(MP(*it, i)) == 0)
            dwyn.insert(MP(i, *it));
    return 1;
}

int main()
{
    int n, m, k;
    scanf("%d%d%d", &n, &m, &k);
    vector<PII> kraw;
    vector<PII> wymagania;

    REP(i, m)
    {
        int a, b;
        scanf("%d%d",&a, &b);
        a --; b --;
        kraw.PB(MP(a,b));
        graf[a].PB(b);
        graf[b].PB(a);
    }
    REP(i, k)
    {
        int a, b;
        scanf("%d%d",&a, &b);
        a --; b --;
        wymagania.PB(MP(a,b));
    }
    
    if(rozwiaz_drzewo(n, graf, wymagania) == 0)
    {
        printf("NO\n");
        return 0;
    }

    set<PII> wynik;
    REP(i, n)
        FORE(it, graf[i])
        {
            if(dwyn.count(MP(i, *it)))
                wynik.insert(MP(i, *it));
            else
                wynik.insert(MP(*it, i));
        }
    printf("YES\n");
    FORE(it, kraw)
    {
        if(wynik.count(MP(it->X, it->Y)))
            printf("%d %d\n", it->X+1, it->Y+1);
        else
            printf("%d %d\n", it->Y+1, it->X+1);
    }
    return 0;
}
